Index: orxonox/branches/levelloader/src/lib/coord/null_parent.h
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/null_parent.h	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/coord/null_parent.h	(revision 3746)
@@ -8,5 +8,5 @@
 #define _NULL_PARENT_H
 
-#include "stdincl.h"
+
 #include "p_node.h"
 
@@ -19,6 +19,6 @@
 
 
-  virtual void update ();
-
+  virtual void update (float dt);
+  
  private:
   NullParent ();
Index: orxonox/branches/levelloader/src/lib/coord/p_node.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/p_node.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/coord/p_node.cc	(revision 3746)
@@ -21,7 +21,15 @@
 
 #include "p_node.h"
-
+#include "stdincl.h"
+
+#include "error.h"
+#include "debug.h"
+#include "list.h"
+#include "vector.h"
 #include "null_parent.h"
-#include "vector.h"
+
+
+//#include "vector.h"
+//#include "quaternion.h"
 
 using namespace std;
@@ -52,12 +60,12 @@
   this->init(parent);
 
-  this->absCoordinate = *absCoordinate;
+  *this->absCoordinate = *absCoordinate;
   if (parent != NULL)
     {
-      this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
+      *this->relCoordinate = *this->absCoordinate - parent->getAbsCoor ();
       parent->addChild (this);
     }
   else 
-    this->relCoordinate = Vector(0,0,0);
+    this->relCoordinate = new Vector(0,0,0);
 }
 
@@ -94,4 +102,5 @@
 }
 
+
 void PNode::init(PNode* parent)
 {
@@ -103,4 +112,10 @@
   this->parent = parent; 
   this->objectName = NULL;
+
+  this->absCoordinate = new Vector();
+  this->relCoordinate = new Vector();
+  this->absDirection = new Quaternion();
+  this->relDirection = new Quaternion();
+  this->lastAbsCoordinate = new Vector();
 }
 
@@ -129,9 +144,12 @@
    \brief get relative coordinates
    \returns relative coordinates to its parent
-*/
-Vector PNode::getRelCoor ()
-{
-  Vector r = this->relCoordinate; /* return a copy, so it can't be modified */
-  return r;
+   
+   the reference that is returned is a pointer to the real relCoor, so don't 
+   change it unless you realy know what you are doing.
+*/
+Vector* PNode::getRelCoor ()
+{
+  //Vector r = *this->relCoordinate; /* return a copy, so it can't be modified */
+  return this->relCoordinate;
 }
 
@@ -148,5 +166,20 @@
 {
   this->bRelCoorChanged = true;
-  this->relCoordinate = *relCoord;
+  *this->relCoordinate = *relCoord;
+}
+
+
+/**
+   \brief set relative coordinates
+   \param relCoord relative coordinates to its parent
+
+   it is very importand, that you use this function, if you want to update the
+   relCoordinates. If you don't use this, the PNode won't recognize, that something
+   has changed and won't update the children Nodes.
+*/
+void PNode::setRelCoor (Vector relCoord)
+{
+  this->bRelCoorChanged = true;
+  *this->relCoordinate = relCoord;
 }
 
@@ -158,5 +191,5 @@
 Vector PNode::getAbsCoor ()
 {
-  return this->absCoordinate;
+  return *this->absCoordinate;
 }
 
@@ -172,5 +205,20 @@
 {
   this->bAbsCoorChanged = true;
-  this->absCoordinate = *absCoord;
+  *this->absCoordinate = *absCoord;
+}
+
+
+
+/**
+   \param absCoord set absolute coordinate
+
+   it is very importand, that you use this function, if you want to update the
+   absCoordinates. If you don't use this, the PNode won't recognize, that something
+   has changed and won't update the children Nodes.
+*/
+void PNode::setAbsCoor (Vector absCoord)
+{
+  this->bAbsCoorChanged = true;
+  *this->absCoordinate = absCoord;
 }
 
@@ -200,9 +248,44 @@
   if( this->bAbsCoorChanged)
     {
-      this->absCoordinate = this->absCoordinate + *shift;
+      *this->absCoordinate = *this->absCoordinate + *shift;
     }
   else 
     {
-      this->relCoordinate = this->relCoordinate + *shift;
+      *this->relCoordinate = *this->relCoordinate + *shift;
+      this->bRelCoorChanged = true;
+    }
+}
+
+
+
+/**
+   \brief shift coordinate (abs and rel)
+   \param shift vector
+
+   this function shifts the current coordinates about the vector shift. this is
+   usefull because from some place else you can:
+   PNode* someNode = ...;
+   Vector objectMovement = calculateShift();
+   someNode->shiftCoor(objectMovement);
+
+   elsewhere you would have to:
+   PNode* someNode = ...;
+   Vector objectMovement = calculateShift();
+   Vector currentCoor = someNode->getRelCoor();
+   Vector newCoor = currentCoor + objectMovement;
+   someNode->setRelCoor(newCoor);
+   
+   yea right... shorter...
+
+*/
+void PNode::shiftCoor (Vector shift)
+{
+  if( this->bAbsCoorChanged)
+    {
+      *this->absCoordinate = *this->absCoordinate + shift;
+    }
+  else 
+    {
+      *this->relCoordinate = *this->relCoordinate + shift;
       this->bRelCoorChanged = true;
     }
@@ -217,5 +300,5 @@
 Quaternion PNode::getRelDir ()
 {
-  return this->relDirection;
+  return *this->relDirection;
 }
 
@@ -232,5 +315,12 @@
 {
   this->bRelCoorChanged = true;
-  this->relDirection = *relDir;
+  *this->relDirection = *relDir;
+}
+
+
+void PNode::setRelDir (Quaternion relDir)
+{
+  this->bRelCoorChanged = true;
+  *this->relDirection = relDir;
 }
 
@@ -242,5 +332,5 @@
 Quaternion PNode::getAbsDir ()
 {
-  return this->absDirection;
+  return *this->absDirection;
 }
 
@@ -257,6 +347,23 @@
 {
   this->bAbsDirChanged = true;
-  this->absDirection = *absDir;
-}
+  *this->absDirection = *absDir;
+}
+
+
+
+/**
+   \brief sets the absolute direction (0,0,1)
+   \param absDir absolute coordinates
+
+   it is very importand, that you use this function, if you want to update the
+   absDirection. If you don't use this, the PNode won't recognize, that something
+   has changed and won't update the children Nodes.
+*/
+void PNode::setAbsDir (Quaternion absDir)
+{
+  this->bAbsDirChanged = true;
+  *this->absDirection = absDir;
+}
+
 
 
@@ -285,4 +392,44 @@
 {}
 
+
+/**
+   \brief shift coordinate (abs and rel)
+   \param shift vector
+
+   this function shifts the current coordinates about the vector shift. this is
+   usefull because from some place else you can:
+   PNode* someNode = ...;
+   Quaternion objectMovement = calculateShift();
+   someNode->shiftCoor(objectMovement);
+
+   elsewhere you would have to:
+   PNode* someNode = ...;
+   Quaternion objectMovement = calculateShift();
+   Quaternion currentCoor = someNode->getRelCoor();
+   Quaternion newCoor = currentCoor + objectMovement;
+   someNode->setRelCoor(newCoor);
+   
+   yea right... shorter...
+
+   \todo implement this
+*/
+void PNode::shiftDir (Quaternion shift)
+{}
+
+
+/**
+   \brief this calculates the current movement speed of the node
+*/
+float PNode::getSpeed()
+{
+  if(this->time == 0)
+    return 1000;
+  Vector diff;
+  diff = *this->absCoordinate - *this->lastAbsCoordinate;
+  float x = diff.len();
+  return x / this->time;
+}
+
+
 /**
    \brief adds a child and makes this node to a parent
@@ -308,5 +455,5 @@
   if( pNode->parent != NULL )
     {
-      PRINTF(2)("PNode::addChild() - reparenting node: removing it and adding it again\n");
+      PRINTF(3)("PNode::addChild() - reparenting node: removing it and adding it again\n");
       pNode->parent->children->remove(pNode);
     }
@@ -338,12 +485,17 @@
 void PNode::remove()
 {
-  NullParent* np = NullParent::getInstance();
-  PNode* pn = this->children->enumerate();
+  NullParent* nullParent = NullParent::getInstance();
+
+  tIterator<PNode>* iterator = this->children->getIterator();
+  PNode* pn = iterator->nextElement();
+ 
   while( pn != NULL) 
     { 
-      this->children->remove(pn);
-      np->addChild(pn, pn->getMode());
-      pn = this->children->nextElement();
-    }
+      //this->children->remove(pn);
+      nullParent->addChild(pn, pn->getMode());
+      pn = iterator->nextElement();
+    }
+  delete iterator;
+  this->parent->children->remove(this);
 }
 
@@ -410,8 +562,9 @@
    worry, normaly...
 */
-void PNode::update ()
-{
-  PRINTF(2)("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
-  // printf("%s", this->objectName);
+void PNode::update (float dt)
+{
+  *this->lastAbsCoordinate = *this->absCoordinate;
+  this->time = dt;
+  PRINTF(4)("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate->x, this->absCoordinate->y, this->absCoordinate->z);
   if(this->mode & PNODE_MOVEMENT )
     {
@@ -419,5 +572,5 @@
 	{
 	  /* if you have set the absolute coordinates this overrides all other changes */
-	  this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
+	  *this->relCoordinate = *this->absCoordinate - parent->getAbsCoor ();
 	}
       else if( this->bRelCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
@@ -426,8 +579,8 @@
 	  if( this->parent == NULL)
 	    {
-	      this->absCoordinate = this->relCoordinate;
+	      *this->absCoordinate = *this->relCoordinate;
 	    }
 	  else
-	    this->absCoordinate = parent->getAbsCoor() + this->relCoordinate;	      /* update the current absCoordinate */
+	    *this->absCoordinate = parent->getAbsCoor() + *this->relCoordinate;	      /* update the current absCoordinate */
 	}
     }
@@ -438,10 +591,10 @@
 	{
 	  /* if you have set the absolute coordinates this overrides all other changes */
-	  this->relDirection = this->absDirection - parent->getAbsDir();
+	  *this->relDirection = *this->absDirection - parent->getAbsDir();
 	}
       else if( this->bRelDirChanged /*&& this->timeStamp != DataTank::timeStamp*/)
 	{
 	  /* update the current absDirection - remember * means rotation around sth.*/
-	  this->absDirection = parent->getAbsDir() * this->relDirection;
+	  *this->absDirection = parent->getAbsDir() * *this->relDirection;
 	}
     }
@@ -452,5 +605,5 @@
 	{
 	  /* if you have set the absolute coordinates this overrides all other changes */
-	  this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
+	  *this->relCoordinate = *this->absCoordinate - parent->getAbsCoor ();
 	}
       else if( this->bRelCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
@@ -458,12 +611,14 @@
 	  /*this is bad style... must be deleted later - just for testing*/
 	  if( this->parent == NULL)
-	    this->absCoordinate = this->relCoordinate;
+	    *this->absCoordinate = *this->relCoordinate;
 	  else
-	    this->absCoordinate = parent->getAbsCoor() + parent->getAbsDir().apply(this->relCoordinate);	      /* update the current absCoordinate */
+	    *this->absCoordinate = parent->getAbsCoor() + parent->getAbsDir().apply(*this->relCoordinate);	      /* update the current absCoordinate */
 	}
     }
   
   
-  PNode* pn = this->children->enumerate();
+  tIterator<PNode>* iterator = this->children->getIterator();
+  //PNode* pn = this->children->enumerate();
+  PNode* pn = iterator->nextElement();
   while( pn != NULL) 
     { 
@@ -473,7 +628,10 @@
       if( this->bRelDirChanged || this->bAbsDirChanged)
 	pn->parentDirChanged ();
-      pn->update();
-      pn = this->children->nextElement();
-    }
+
+      pn->update(dt);
+      //pn = this->children->nextElement();
+      pn = iterator->nextElement();
+    }
+  delete iterator;
 
   this->timeStamp = timeStamp;
@@ -507,7 +665,7 @@
 {
   PRINTF(2)("PNode::debug() - absCoord: (%f, %f, %f)\n", 
-	 this->absCoordinate.x, 
-	 this->absCoordinate.y,
-	 this->absCoordinate.z);
+	 this->absCoordinate->x, 
+	 this->absCoordinate->y,
+	 this->absCoordinate->z);
 }
 
Index: orxonox/branches/levelloader/src/lib/coord/p_node.h
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/p_node.h	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/coord/p_node.h	(revision 3746)
@@ -23,4 +23,5 @@
 
 #include "base_object.h"
+//#include "vector.h"
 
 // FORWARD DEFINITION \\
@@ -28,4 +29,5 @@
 class Quaternion;
 class Vector;
+template<class T> class tList;
 
 //! enumeration for the different translation-binding-types
@@ -55,18 +57,24 @@
 
 
-  Vector getRelCoor ();
+  Vector* getRelCoor ();
   void setRelCoor (Vector* relCoord);
-  //void setRelCoor (Vector relCoord);
+  void setRelCoor (Vector relCoord);
   Vector getAbsCoor ();
   void setAbsCoor (Vector* absCoord);
-  //void setAbsCoor (Vector absCoord);
+  void setAbsCoor (Vector absCoord);
   void shiftCoor (Vector* shift);
+  void shiftCoor (Vector shift);
   //void shiftCoor (Vector shift);
 
   Quaternion getRelDir ();
   void setRelDir (Quaternion* relDir);
+  void setRelDir (Quaternion relDir);
   Quaternion getAbsDir ();
   void setAbsDir (Quaternion* absDir);
+  void setAbsDir (Quaternion absDir);
   void shiftDir (Quaternion* shift);
+  void shiftDir (Quaternion shift);
+
+  float getSpeed();
 
   void addChild (PNode* pNode);
@@ -82,5 +90,5 @@
   int getMode();
 
-  virtual void update ();
+  virtual void update (float dt);
   void processTick (float dt);
 
@@ -90,7 +98,4 @@
 
   void debug ();
-
- private:
-  void init(PNode* parent);
 
  protected:
@@ -102,11 +107,16 @@
   bool bRelDirChanged;     //!< If Relative Direction has changed since last time we checked
 
-  Vector relCoordinate;    //!< coordinates relative to the parent
-  Vector absCoordinate;    //!< absolute coordinates in the world ( from (0,0,0) )
-  Quaternion relDirection; //!< direction relative to the parent
-  Quaternion absDirection; //!< absolute direvtion in the world ( from (0,0,1) )
+  Vector* relCoordinate;    //!< coordinates relative to the parent
+  Vector* absCoordinate;    //!< absolute coordinates in the world ( from (0,0,0) )
+  Quaternion* relDirection; //!< direction relative to the parent
+  Quaternion* absDirection; //!< absolute direvtion in the world ( from (0,0,1) )
 
   int mode;                //!< the mode of the binding
 
+ private:
+  void init(PNode* parent);
+
+  Vector* lastAbsCoordinate; //!< this is used for speedcalculation, it stores the last coordinate
+  float time;                //!< time since last update
 };
 
Index: orxonox/branches/levelloader/src/lib/graphics/graphics_engine.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/graphics_engine.cc	(revision 3746)
+++ orxonox/branches/levelloader/src/lib/graphics/graphics_engine.cc	(revision 3746)
@@ -0,0 +1,198 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GRAPHICS
+
+#include "graphics_engine.h"
+
+#include "debug.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+   \todo this constructor is not jet implemented - do it
+*/
+GraphicsEngine::GraphicsEngine () 
+{
+  this->setClassName ("GraphicsEngine");
+  this->initVideo();
+
+  this->listModes();
+}
+
+/**
+   \brief The Pointer to this GraphicsEngine
+*/
+GraphicsEngine* GraphicsEngine::singletonRef = NULL;
+
+/**
+   \returns A pointer to this GraphicsEngine
+*/
+GraphicsEngine* GraphicsEngine::getInstance()
+{
+  if (!GraphicsEngine::singletonRef)
+    GraphicsEngine::singletonRef = new GraphicsEngine();
+  return GraphicsEngine::singletonRef;
+}
+
+
+/**
+   \brief destructs the graphicsEngine.
+*/
+GraphicsEngine::~GraphicsEngine () 
+{
+  // delete what has to be deleted here
+}
+
+/**
+   \brief initializes the Video for openGL.
+
+   This has to be done only once when starting orxonox.
+*/
+int GraphicsEngine::initVideo()
+{
+  // initialize SDL_VIDEO
+  if (SDL_Init(SDL_INIT_VIDEO) == -1)
+    {
+      PRINTF(1)("could not initialize SDL Video\n");
+      //      return -1;
+    }
+  // initialize SDL_GL-settings
+  this->setGLattribs();
+
+  // setting the Video Flags.
+  this->videoFlags = SDL_OPENGL | SDL_HWPALETTE | SDL_RESIZABLE | SDL_DOUBLEBUF;
+
+  /* query SDL for information about our video hardware */
+  const SDL_VideoInfo* videoInfo = SDL_GetVideoInfo ();
+  if( videoInfo == NULL)
+    {
+      PRINTF(1)("Failed getting Video Info :%s\n", SDL_GetError()); 
+      SDL_Quit ();
+    }
+  if( videoInfo->hw_available)
+    this->videoFlags |= SDL_HWSURFACE;
+  else 
+    this->videoFlags |= SDL_SWSURFACE;
+  /*
+  if(VideoInfo -> blit_hw)
+    VideoFlags |= SDL_HWACCEL;
+  */
+
+  // setting up the Resolution
+  this->setResolution(800, 600, 16);
+  
+  // Set window labeling
+  SDL_WM_SetCaption ("Orxonox " PACKAGE_VERSION, "Orxonox " PACKAGE_VERSION);
+  
+  // TO DO: Create a cool icon and use it here
+  SDL_WM_SetIcon(SDL_LoadBMP("../data/pictures/orxonox-icon32x32.bmp"), NULL);  
+
+  // Enable default GL stuff
+  glEnable(GL_DEPTH_TEST);
+}
+
+/**
+   \brief Sets the GL-attributes
+*/
+int GraphicsEngine::setGLattribs(void)
+{
+  // Set video mode
+  // TO DO: parse arguments for settings
+  //SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);
+  //SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);
+  //SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);
+  //SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);
+  
+
+  SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );   
+  SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16);    
+  SDL_GL_SetAttribute( SDL_GL_STENCIL_SIZE, 0);  
+  SDL_GL_SetAttribute( SDL_GL_ACCUM_RED_SIZE, 0);
+  SDL_GL_SetAttribute( SDL_GL_ACCUM_GREEN_SIZE, 0);
+  SDL_GL_SetAttribute( SDL_GL_ACCUM_BLUE_SIZE, 0);
+  SDL_GL_SetAttribute( SDL_GL_ACCUM_ALPHA_SIZE, 0);
+}
+
+/**
+   \brief sets the Resolution of the Screen to display the Graphics to.
+   \param width The width of the window
+   \param height The height of the window
+   \param bpp bits per pixel
+*/
+int GraphicsEngine::setResolution(int width, int height, int bpp)
+{
+  this->resolutionX = width;
+  this->resolutionY = height;
+  this->bitsPerPixel = bpp;
+  
+  printf ("ok\n");
+  if((this->screen = SDL_SetVideoMode(this->resolutionX, this->resolutionY, this->bitsPerPixel, this->videoFlags)) == NULL)
+    {
+      PRINTF(1)("Could not SDL_SetVideoMode(%d, %d, %d, %d): %s\n", this->resolutionX, this->resolutionY, this->bitsPerPixel, this->videoFlags, SDL_GetError());
+      SDL_Quit();
+      //    return -1;
+    }
+
+}
+
+/**
+   \brief Signalhandler, for when the resolution has changed
+   \param resizeInfo SDL information about the size of the new screen size
+*/
+int GraphicsEngine::resolutionChanged(SDL_ResizeEvent* resizeInfo)
+{
+  this->setResolution(resizeInfo->w, resizeInfo->h, this->bitsPerPixel);
+}
+
+/**
+   \brief if Textures should be enabled
+*/
+bool GraphicsEngine::texturesEnabled = true;
+
+
+
+
+
+
+
+/**
+   \brief outputs all the Fullscreen modes.
+*/
+void GraphicsEngine::listModes(void)
+{
+  /* Get available fullscreen/hardware modes */
+  this->videoModes=SDL_ListModes(NULL, SDL_FULLSCREEN|SDL_HWSURFACE);
+  
+  /* Check is there are any modes available */
+  if(this->videoModes == (SDL_Rect **)0){
+    PRINTF(1)("No modes available!\n");
+    exit(-1);
+  }
+  
+  /* Check if our resolution is restricted */
+  if(this->videoModes == (SDL_Rect **)-1){
+    PRINTF(1)("All resolutions available.\n");
+  }
+  else{
+    /* Print valid modes */
+    PRINT(0)("Available Resoulution Modes are\n");
+    for(int i = 0; this->videoModes[i]; ++i)
+      PRINT(0)(" |  %d x %d\n", this->videoModes[i]->w, this->videoModes[i]->h);
+  }
+  
+}
Index: orxonox/branches/levelloader/src/lib/graphics/graphics_engine.h
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/graphics_engine.h	(revision 3746)
+++ orxonox/branches/levelloader/src/lib/graphics/graphics_engine.h	(revision 3746)
@@ -0,0 +1,48 @@
+/*! 
+    \file graphics_engine.h
+    
+    \brief defines a Interface between orxonox and graphical input
+
+    handles graphical SDL-initialisation, textures, resolutions, and so on
+*/
+
+#ifndef _GRAPHICS_ENGINE_H
+#define _GRAPHICS_ENGINE_H
+
+#include "glincl.h"
+
+#include "base_object.h"
+
+// FORWARD DEFINITION \\
+
+
+class GraphicsEngine : public BaseObject 
+{
+ public:
+  static GraphicsEngine* getInstance();
+  virtual ~GraphicsEngine();
+
+  int initVideo();
+  int setGLattribs(void);
+  int setResolution(int width, int height, int bpp);
+  int resolutionChanged(SDL_ResizeEvent* resizeInfo);
+  void listModes(void);
+
+  static bool texturesEnabled;
+
+ private:
+  GraphicsEngine();
+  static GraphicsEngine* singletonRef;
+
+
+  SDL_Surface* screen;
+  int resolutionX;
+  int resolutionY;
+  int bitsPerPixel;
+  bool fullscreen;
+  Uint32 videoFlags;
+
+  SDL_Rect **videoModes;
+};
+
+#endif /* _GRAPHICS_ENGINE_H */
Index: orxonox/branches/levelloader/src/lib/graphics/importer/Makefile.am
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/Makefile.am	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/Makefile.am	(revision 3746)
@@ -5,5 +5,5 @@
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/data
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gaphics
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/importer
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/lang
@@ -27,8 +27,12 @@
 	  	  model.cc \
 		  objModel.cc \
+		  primitive_model.cc \
 	  	  array.cc \
 	  	  material.cc \
 		  texture.cc \
-		  $(MAINSRCDIR)/lib/math/vector.cc
+		  $(MAINSRCDIR)/lib/graphics/graphics_engine.cc \
+		  $(MAINSRCDIR)/lib/lang/base_object.cc \
+		  $(MAINSRCDIR)/lib/math/vector.cc \
+		  $(MAINSRCDIR)/lib/util/resource_manager.cc
 
 noinst_HEADERS= framework.h \
@@ -36,4 +40,5 @@
 	  	model.h \
 		objModel.h \
+		primitive_model.h \
 	  	array.h \
 		material.h \
Index: orxonox/branches/levelloader/src/lib/graphics/importer/framework.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/framework.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/framework.cc	(revision 3746)
@@ -17,4 +17,7 @@
 
 #include "vector.h"
+
+#include "primitive_model.h"
+
 
 int verbose;
@@ -76,45 +79,6 @@
     obj = new OBJModel(argv[1]);
   else 
-    {
-      // This is an example, of how it is possible, to create a new Model, and adding some vertex-information.
-      // This also packs everything into a DisplayList, and can be handled exactly as any other model.
-      // This is an example of a cube with Texture-Coordinates, but without explicite Vertex-Normals. (they are soft-created).
-      /*
-      obj = (OBJModel*) new Model();
-      obj->setName("CUBE");
-      obj->addVertex (-0.5, -0.5, 0.5);
-      obj->addVertex (0.5, -0.5, 0.5);
-      obj->addVertex (-0.5, 0.5, 0.5);
-      obj->addVertex (0.5, 0.5, 0.5);
-      obj->addVertex (-0.5, 0.5, -0.5);
-      obj->addVertex (0.5, 0.5, -0.5);
-      obj->addVertex (-0.5, -0.5, -0.5);
-      obj->addVertex (0.5, -0.5, -0.5);
-      
-      obj->addVertexTexture (0.0, 0.0);
-      obj->addVertexTexture (1.0, 0.0);
-      obj->addVertexTexture (0.0, 1.0);
-      obj->addVertexTexture (1.0, 1.0);
-      obj->addVertexTexture (0.0, 2.0);
-      obj->addVertexTexture (1.0, 2.0);
-      obj->addVertexTexture (0.0, 3.0);
-      obj->addVertexTexture (1.0, 3.0);
-      obj->addVertexTexture (0.0, 4.0);
-      obj->addVertexTexture (1.0, 4.0);
-      obj->addVertexTexture (2.0, 0.0);
-      obj->addVertexTexture (2.0, 1.0);
-      obj->addVertexTexture (-1.0, 0.0);
-      obj->addVertexTexture (-1.0, 1.0);
-
-      obj->addFace ("1 2 4 3");
-      obj->addFace ("3 4 6 5");
-      obj->addFace ("5 6 8 7");
-      obj->addFace ("7 8 2 1");
-      obj->addFace ("2 8 6 4");
-      obj->addFace ("7 1 3 5");
-      obj->finalize();
-      */
-      obj = (OBJModel*) new Model(CYLINDER);
-    }
+    obj = new PrimitiveModel(SPHERE);
+
   M = Vector(wHandler.screen->w/2, wHandler.screen->h/2, 0); 
   rotAxis = Vector (0.0,1.0,0.0);
@@ -166,5 +130,5 @@
       switch (event.type) {
       case SDL_MOUSEMOTION:
-	PRINTF(3)("Mouse motion about %d,%d Pixels to (%d,%d).\n", 
+	PRINTF(4)("Mouse motion about %d,%d Pixels to (%d,%d).\n", 
 		  event.motion.xrel, event.motion.yrel,
 		  event.motion.x, event.motion.y);
@@ -205,10 +169,10 @@
 	if (event.button.button == 4)
 	  {
-	    PRINTF(0)("MouseWheel up\n");
+	    PRINTF(4)("MouseWheel up\n");
 	    zoomTo *= .5;
 	  }
 	else if (event.button.button == 5)
 	  {
-	    PRINTF(2)("MouseWheel down\n");
+	    PRINTF(4)("MouseWheel down\n");
 	    zoomTo *= 2.0;
 	  }
@@ -240,5 +204,5 @@
 	else 
 	    {
-	      PRINTF(2)("MouseButton %d released at (%d,%d).\n",
+	      PRINTF(4)("MouseButton %d released at (%d,%d).\n",
 			event.button.button, event.button.x, event.button.y);
 	    }
Index: orxonox/branches/levelloader/src/lib/graphics/importer/framework.h
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/framework.h	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/framework.h	(revision 3746)
@@ -4,4 +4,5 @@
 #include "windowHandler.h" // Include the Whandler Basecode
 #include "objModel.h"
+#include "vector.h"
 
 class Vector;
@@ -34,5 +35,5 @@
 
 WindowHandler wHandler;  // Create an instance of the whandler basecode class
-OBJModel* obj;
+Model* obj;
 
 
Index: orxonox/branches/levelloader/src/lib/graphics/importer/material.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/graphics/importer/material.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/graphics/importer/material.cc	(revision 3746)
@@ -21,6 +21,10 @@
 #include "texture.h"
 #include "debug.h"
+#include "resource_manager.h"
 #include <stdlib.h>
 #include <string.h>
+
+//! \todo check if we are in RESOURCE MANAGER-mode
+#include "resource_manager.h"
 
 using namespace std;
@@ -58,5 +62,5 @@
     delete []this->name;
   if (this->diffuseTexture)
-    this->diffuseTexture;
+    ResourceManager::getInstance()->unload(this->diffuseTexture);
   if (this->nextMat)
     delete this->nextMat;
@@ -89,5 +93,5 @@
   this->nextMat = NULL;
   this->name ="";
-  this->setIllum(1);
+  this->setIllum(3);
   this->setDiffuse(0,0,0);
   this->setAmbient(0,0,0);
@@ -104,6 +108,4 @@
   this->ambientTextureSet = false;
   this->specularTextureSet = false;
-
-  
 }
 
@@ -167,5 +169,4 @@
 }
 
-
 /**
    \brief Set the Name of the Material. (Important for searching)
@@ -321,5 +322,5 @@
 void Material::addTexturePath(char* pathName)
 {
-  PathList::getInstance()->addPath(pathName);
+  ResourceManager::getInstance()->addImageDir(pathName);
 }
 
@@ -333,7 +334,10 @@
 {
   PRINTF(4)("setting Diffuse Map %s\n", dMap);
-  diffuseTexture = new Texture();
-  this->diffuseTextureSet = diffuseTexture->loadImage(dMap);
-
+  //    diffuseTexture = new Texture();
+  //    this->diffuseTextureSet = diffuseTexture->loadImage(dMap);
+
+  //! \todo check if RESOURCE MANAGER is availiable
+  //! \todo Textures from .mtl-file need special care.
+  this->diffuseTextureSet = this->diffuseTexture = (Texture*)ResourceManager::getInstance()->load(dMap, IMAGE);
 }
 
